function [allfiltered, allmaxed] = applyfilter1(I, allfilter, totalScale);
% filter image by a bank of filters
% I: input images
% allfilter: filter bank
% threshold: filter response is set to zero if below threshold

nimage = size(I, 2);    % number of training images
norient = size(allfilter, 2);     % number of orientations
h = (size(allfilter{1}, 1)-1)/2;  % half size of filters
allfiltered = cell(nimage, norient);  % filtered images
allmaxed = cell(nimage, norient); 
for (img = 1 : floor(nimage/totalScale+.5))
  tot = 0.; totn = 0.;
  for (j = 1 : floor(totalScale+.5))
   i = floor((img-1)*totalScale+j+.5);
   [sx, sy] = size(I{i});  % size of images  
   for o = 1 : norient
       filtered = filter2(allfilter{1, o}, I{i}, 'same');
       re = real(filtered); im = imag(filtered); 
       energy = re.*re + im.*im;  % compute the local energy
       allfiltered{i, o} = energy; 
       tot = tot + sum(sum(energy((h+1):(sx-h-1), (h+1):(sy-h-1)))); 
       totn = totn + (sx-2*h-1)*(sy-2*h-1);
       allmaxed{i, o} = zeros(sx, sy); 
   end
  end
  ave = tot/totn; 

  for (j = 1 : floor(totalScale+.5))
   i = floor((img-1)*totalScale+j+.5);
   for o = 1 : norient
       allfiltered{i, o} = allfiltered{i, o}/ave;  % normalizing by whitening
   end
  end
end

    

