function [allfiltered, allmaxed] = applyfilter2(I, allfilter);
% filter image by a bank of filters
% I: input images
% allfilter: filter bank
% threshold: filter response is set to zero if below threshold

nimage = size(I, 2);    % number of training images
norient = size(allfilter, 2);     % number of orientations
h = (size(allfilter{1}, 1)-1)/2;  % half size of filters
allfiltered = cell(nimage, norient);  % filtered images
allmaxed = cell(nimage, norient); 
for (i = 1 : nimage)
   [sx, sy] = size(I{i});  % size of images  
   J = I{i}; v = var(J(:)); 
   for o = 1 : norient
       filtered = filter2(allfilter{1, o}, I{i}, 'same');
       re = real(filtered); im = imag(filtered); 
       energy = re.*re + im.*im;  % compute the local energy
       allfiltered{i, o} = energy/v/2.; 
       allmaxed{i, o} = zeros(sx, sy); 
   end
end

    

